package request

//驳回申请合同请求
type RejectReq struct {
	ContractApprovalRecordId int    `description:"审批流id"`
	Remark                   string `description:"驳回理由"`
}

//通过申请合同请求
type ApprovedReq struct {
	ContractApprovalRecordId int    `description:"审批流id"`
	Remark                   string `description:"驳回理由"`
	NextApproval             bool   `description:"是否需要下级批准，预留字段，一期用不到，二期加入合规审批流程的时候，合规审批操作后可能会用到"`
	NextApprovalUserId       int    `description:"是否指定下级审批人，预留字段，一期用不到，二期加入合规审批流程的时候，合规审批操作后可能会用到"`
}
