package request

// ModifyEdbNoPermissionAdminReq 编辑指标无权限用户列表
type ModifyEdbNoPermissionAdminReq struct {
	EdbInfoId   int   `description:"指标id"`
	AdminIdList []int `description:"用户id列表"`
}

// DelEdbNoPermissionAdminReq 删除指标无权限用户列表
type DelEdbNoPermissionAdminReq struct {
	EdbInfoId int `description:"指标id"`
	AdminId   int `description:"用户id"`
}

// BatchAddEdbNoPermissionAdminReq 批量添加指标无权限用户列表
type BatchAddEdbNoPermissionAdminReq struct {
	EdbInfoIdList []int `description:"指标id列表"`
	AdminIdList   []int `description:"用户id列表"`
}
