package request

type AddRoleAdminReq struct {
	AdminIds     string `description:"需要新增的管理账号ID，用英文逗号拼接"`
	RoleTypeCode string `description:"角色类型编码：留言板管理员：yb_comment_admin"`
}

type DelRoleAdminReq struct {
	SysRoleAdminId int `description:"需要删除的绑定ID"`
}

// DelEnglishAuthRoleAdminReq 删除英文权限请求体
type DelEnglishAuthRoleAdminReq struct {
	AdminId int `description:"管理员ID"`
}

// AddEnglishAuthRoleAdminReq 批量新增英文权限请求体
type AddEnglishAuthRoleAdminReq struct {
	AdminIds string `description:"需要新增的管理账号ID，用英文逗号拼接"`
}

// EditEnglishAuthRoleAdminReq 编辑英文权限请求体
type EditEnglishAuthRoleAdminReq struct {
	AdminId       int    `description:"管理员ID"`
	RoleTypeCodes string `description:"角色类型编码, 英文逗号拼接"`
}
