package request

type QuestionDeleteReq struct {
	QuestionId int `description:"问题ID"`
}

type QuestionDistributeReq struct {
	QuestionId            int `description:"问题ID"`
	AdminId               int `description:"研究员ID"`
	ResearchGroupFirstId  int `description:"研究方向一级分组ID"`
	ResearchGroupSecondId int `description:"研究方向二级分组ID"`
}

type QuestionMsgSendReq struct {
	QuestionId int `description:"问题ID"`
}

type QuestionEditReq struct {
	QuestionId      int    `description:"问题ID"`
	QuestionContent string `description:"问题内容"`
}

// QuestionTransferReq 问答转移请求体
type QuestionTransferReq struct {
	QuestionId            int `description:"问题ID"`
	ResearchGroupFirstId  int `description:"研究方向一级分组ID"`
	ResearchGroupSecondId int `description:"研究方向二级分组ID"`
	AdminId               int `description:"研究员ID"`
}
