package request

type CommunityVideoSaveReq struct {
	VideoId      int    `description:"视频ID"`
	Title        string `description:"视频标题"`
	VarietyTagId int    `description:"标签ID"`
	CoverImgUrl  string `description:"封面图地址"`
	VideoUrl     string `description:"视频地址"`
	VideoSeconds string `description:"视频时长，单位秒"`
}

type CommunityVideoOptionReq struct {
	VideoId int `description:"问题ID"`
}

type CommunityVideoPublishReq struct {
	VideoId      int `description:"问题ID"`
	PublishState int `description:"发布状态：0-未发布 1-已发布"`
}

type CommunityVideoCoverSaveReq struct {
	CoverId   int    `description:"封面ID"`
	CoverName string `description:"封面名称"`
	CoverUrl  string `description:"封面图地址"`
	Type      int8   `description:"封面类型（1 视频社区，2 路演视频）"`
}

type CommunityVideoCoverOptionReq struct {
	CoverId int `description:"封面图ID"`
}
