package request

type RoadVideoSaveReq struct {
	VideoId            int    `description:"视频ID"`
	Title              string `description:"视频标题"`
	ChartPermissionIds string `description:"品种ID,用英文逗号拼接"`
	CoverImgUrl        string `description:"封面图地址"`
	VideoUrl           string `description:"视频地址"`
	VideoSeconds       string `description:"视频时长，单位秒"`
	ReportId           int    `description:"关联的报告ID"`
}

type RoadVideoOptionReq struct {
	VideoId int `description:"问题ID"`
}

type RoadVideoPublishReq struct {
	VideoId      int `description:"问题ID"`
	PublishState int `description:"发布状态：0-未发布 1-已发布"`
}
