package response

import (
	"github.com/rdlucklib/rdluck_tools/paging"
	"hongze/hz_crm_api/models"
	"hongze/hz_crm_api/models/yb"
)

// ListResp 列表数据返回
type ListResp struct {
	Paging *paging.PagingItem
	List   []*yb.ActivityList `description:"列表数据"`
}

// AddActivityResp 新增活动数据返回
type AddActivityResp struct {
	ActivityId int `description:"活动id"`
}

// SpeakerListResp 主讲人列表数据返回
type SpeakerListResp struct {
	List []*yb.Speaker `description:"列表数据"`
}

// ResearchReportListResp 报告列表数据返回
type ResearchReportListResp struct {
	Paging *paging.PagingItem
	List   []*models.ResearchReportList `description:"列表数据"`
}

type ActivityDetailResp struct {
	*yb.Activity
	Poster []*yb.ActivityPoster
}
