package cygx

import "github.com/beego/beego/v2/client/orm"

type CygxYanxuanSpecialFollowResp struct {
	CygxYanxuanSpecialFollowId int    `orm:"column(cygx_yanxuan_special_follow_id);pk"`
	UserId                     int    // 用户ID
	FollowUserId               int    // 被关注用户ID
	Mobile                     string // 手机号
	Email                      string // 邮箱
	CompanyId                  int    // 公司ID
	CompanyName                string // 公司名称
	RealName                   string // 用户实际名称
	SellerName                 string // 所属销售
	CreateTime                 string // 创建时间
	ModifyTime                 string // 修改时间
	RegisterPlatform           int    // 来源 1小程序，2：网页
	YanxuanSpecialId           int    // cygx_yanxuan_special 表主键ID
}

func GetCygxYanxuanSpecialFollowList(condition string, pars []interface{}, startSize, pageSize int) (items []*CygxYanxuanSpecialFollowResp, err error) {
	o := orm.NewOrmUsingDB("hz_cygx")
	sql := ``
	sql = `SELECT * FROM cygx_yanxuan_special_follow AS a WHERE 1=1 `
	if condition != "" {
		sql += condition
	}
	sql += ` LIMIT ?,? `
	_, err = o.Raw(sql, pars, startSize, pageSize).QueryRows(&items)
	return
}

type GetCygxYanxuanSpecialFollowResp struct {
	List []*CygxYanxuanSpecialFollowResp
}
