package request

// AddBaseFromBaiinfoClassifyReq 添加SMM分类请求
type AddBaseFromBaiinfoClassifyReq struct {
	ParentId     int    `description:"上级id"`
	ClassifyName string `description:"分类名称"`
	//Level        int    `description:"层级,第一级传0，其余传上一级的层级"`
}

// EditBaseFromBaiinfoClassifyReq 修改SMM分类请求
type EditBaseFromBaiinfoClassifyReq struct {
	ClassifyName string `description:"分类名称"`
	ClassifyId   int    `description:"分类id"`
}

// MoveBaseFromBaiinfoClassifyReq 移动分类请求参数
type MoveBaseFromBaiinfoClassifyReq struct {
	ClassifyId     int `description:"分类id"`
	ParentId       int `description:"父级分类id"`
	PrevClassifyId int `description:"上一个兄弟节点分类id"`
	NextClassifyId int `description:"下一个兄弟节点分类id"`
}

// DelBaseFromBaiinfoClassifyReq 删除SMM分类请求
type DelBaseFromBaiinfoClassifyReq struct {
	ClassifyId int `description:"分类id"`
}

// MoveBaseFromBaiinfoReq 移动指标请求参数
type MoveBaseFromBaiinfoReq struct {
	ClassifyId                 int `description:"分类id"`
	BaseFromBaiinfoIndexId     int `description:"指标id"`
	PrevBaseFromBaiinfoIndexId int `description:"上一个兄弟节点分类id"`
	NextBaseFromBaiinfoIndexId int `description:"下一个兄弟节点分类id"`
}

// EditBaseFromBaiinfoReq 编辑SMM指标
type EditBaseFromBaiinfoReq struct {
	BaseFromBaiinfoIndexId int    `description:"指标id"`
	ClassifyId             int    `description:"分类id"`
	Frequency              string `description:"频度"`
	Unit                   string `description:"单位"`
}

// DelBaseFromBaiinfoReq 删除SMM指标
type DelBaseFromBaiinfoReq struct {
	BaseFromBaiinfoIndexId int `description:"指标id"`
}
