package request

// AddExcelClassifyReq 添加excel分类请求
type AddExcelClassifyReq struct {
	ExcelClassifyName string `description:"分类名称"`
	ParentId          int    `description:"父级id,第一级传0" json:"-"`
	Level             int    `description:"层级,第一级传0，其余传上一级的层级" json:"-"`
}

// EditExcelClassifyReq 修改excel分类请求
type EditExcelClassifyReq struct {
	ExcelClassifyName string `description:"分类名称"`
	ExcelClassifyId   int    `description:"分类名称"`
}

// MoveExcelClassifyReq 移动图表分类请求参数
type MoveExcelClassifyReq struct {
	ClassifyId       int `description:"分类id"`
	ParentClassifyId int `description:"父级分类id" json:"-"`
	PrevClassifyId   int `description:"上一个兄弟节点分类id"`
	NextClassifyId   int `description:"下一个兄弟节点分类id"`
}

type DeleteExcelClassifyReq struct {
	ExcelClassifyId int `description:"分类id"`
	ExcelInfoId     int `description:"表格id"`
}

type ExcelClassifyDeleteCheckReq struct {
	ExcelClassifyId int `description:"分类id"`
	ExcelInfoId     int `description:"表格id"`
}
