package request

// AddBaseFromSciClassifyReq 添加SMM分类请求
type AddBaseFromSciClassifyReq struct {
	ParentId     int    `description:"上级id"`
	ClassifyName string `description:"分类名称"`
	//Level        int    `description:"层级,第一级传0，其余传上一级的层级"`
}

// EditBaseFromSciClassifyReq 修改SMM分类请求
type EditBaseFromSciClassifyReq struct {
	ClassifyName string `description:"分类名称"`
	ClassifyId   int    `description:"分类id"`
}

// MoveBaseFromSciClassifyReq 移动分类请求参数
type MoveBaseFromSciClassifyReq struct {
	ClassifyId     int `description:"分类id"`
	ParentId       int `description:"父级分类id"`
	PrevClassifyId int `description:"上一个兄弟节点分类id"`
	NextClassifyId int `description:"下一个兄弟节点分类id"`
}

// DelBaseFromSciClassifyReq 删除SMM分类请求
type DelBaseFromSciClassifyReq struct {
	ClassifyId int `description:"分类id"`
}

// MoveBaseFromSciReq 移动指标请求参数
type MoveBaseFromSciReq struct {
	ClassifyId             int `description:"分类id"`
	BaseFromSciIndexId     int `description:"指标id"`
	PrevBaseFromSciIndexId int `description:"上一个兄弟节点分类id"`
	NextBaseFromSciIndexId int `description:"下一个兄弟节点分类id"`
}


// EditBaseFromSciReq 编辑SMM指标
type EditBaseFromSciReq struct {
	BaseFromSciIndexId int `description:"指标id"`
	ClassifyId         int `description:"分类id"`
}

// DelBaseFromSciReq 删除SMM指标
type DelBaseFromSciReq struct {
	BaseFromSciIndexId int `description:"指标id"`
}
