package request

// AddBaseFromSmmClassifyReq 添加SMM分类请求
type AddBaseFromSmmClassifyReq struct {
	ParentId     int    `description:"上级id"`
	ClassifyName string `description:"分类名称"`
	//Level        int    `description:"层级,第一级传0，其余传上一级的层级"`
}

// EditBaseFromSmmClassifyReq 修改SMM分类请求
type EditBaseFromSmmClassifyReq struct {
	ClassifyName string `description:"分类名称"`
	ClassifyId   int    `description:"分类id"`
}

// MoveBaseFromSmmClassifyReq 移动分类请求参数
type MoveBaseFromSmmClassifyReq struct {
	ClassifyId     int `description:"分类id"`
	ParentId       int `description:"父级分类id"`
	PrevClassifyId int `description:"上一个兄弟节点分类id"`
	NextClassifyId int `description:"下一个兄弟节点分类id"`
}

// DelBaseFromSmmClassifyReq 删除SMM分类请求
type DelBaseFromSmmClassifyReq struct {
	ClassifyId int `description:"分类id"`
}

// MoveBaseFromSmmReq 移动指标请求参数
type MoveBaseFromSmmReq struct {
	ClassifyId             int `description:"分类id"`
	BaseFromSmmIndexId     int `description:"指标id"`
	PrevBaseFromSmmIndexId int `description:"上一个兄弟节点分类id"`
	NextBaseFromSmmIndexId int `description:"下一个兄弟节点分类id"`
}


// EditBaseFromSmmReq 编辑SMM指标
type EditBaseFromSmmReq struct {
	BaseFromSmmIndexId int `description:"指标id"`
	ClassifyId         int `description:"分类id"`
}

// DelBaseFromSmmReq 删除SMM指标
type DelBaseFromSmmReq struct {
	BaseFromSmmIndexId int `description:"指标id"`
}
