package request

type ModifyReportThsSendPushTimeReq struct {
	SendId   int
	PushTime string
}

// AddThsSentConfReq 添加推送优先配置请求
type AddThsSentConfReq struct {
	ClassifyId int    `description:"所选分类id"`
	ConfigType string `description:"产品类型：研报、语音播报、视频社区、线上路演"`
	Level      int    `description:"等级，1：紧急，2：优先，3：普通"`
}

// EditThsSentConfReq 编辑推送优先配置请求
type EditThsSentConfReq struct {
	ConfigId int `description:"配置id"`
	Level    int `description:"等级，1：紧急，2：优先，3：普通"`
}
