package response

import (
	"github.com/rdlucklib/rdluck_tools/paging"
)

// SpeakerPageListResp 主讲人列表响应体
type SpeakerPageListResp struct {
	Paging *paging.PagingItem
	List   []*SpeakerRespList `description:"列表数据"`
}

// SpeakerRespList 主讲人列表
type SpeakerRespList struct {
	SpeakerId            int    `description:"主讲人ID"`
	SpeakerName          string `description:"主讲人"`
	SpeakerHeadPic       string `description:"主讲人头像"`
	SpeakerBackgroundPic string `description:"主讲人背景图"`
	CreateTime           string `description:"创建时间"`
}

// SpeakerDelCheckResp
type SpeakerDelCheckResp struct {
	Ok  bool   `description:"是否可以删除"`
	Msg string `description:"提示信息"`
}
