package response

import "github.com/rdlucklib/rdluck_tools/paging"

type BulletChatListResp struct {
	Paging *paging.PagingItem
	List   []*BulletChatItem `description:"列表数据"`
}

type BulletChatItem struct {
	Id          int    `description:"弹幕ID"`
	Content     string `description:"弹幕内容"`
	Title       string `description:"视频标题"`
	Source      int    `description:"所属模块: 1-视频社区; 2-线上路演"`
	Seconds     string `description:"时间点"`
	CreateTime  string `description:"发布时间"`
	UserName    string `description:"用户名称"`
	SourceAgent int    `description:"发布来源: 1-小程序; 2-PC端"`
}
