package response

import (
	"github.com/rdlucklib/rdluck_tools/paging"
	"hongze/hz_crm_api/models/yb"
)

// ComeinListResp 进门列表数据返回
type ComeinListResp struct {
	Paging *paging.PagingItem
	List   []*yb.ComeinEventItem `description:"列表数据"`
}

// ComeinUserListResp 到会用户列表数据返回
type ComeinUserListResp struct {
	Paging *paging.PagingItem
	List   []*yb.ComeinEventUser `description:"列表数据"`
}
