package response

import (
	"github.com/rdlucklib/rdluck_tools/paging"
	"hongze/hz_crm_api/models/yb"
)

// QsListResp 到会列表数据返回
type QsListResp struct {
	Paging *paging.PagingItem
	List   []*yb.QsList `description:"列表数据"`
}

// QsUserListResp 到会用户列表数据返回
type QsUserListResp struct {
	Paging *paging.PagingItem
	List   []*yb.QsEventUser `description:"列表数据"`
}
