package utils

const (
	Md5Key = "Ks@h64WJ#tcVgG8$&WlNfqvLAtMgpxWN"
	DesKey = "6WpHp4vSvLVQK8SLioNZ7WMq" // 接口返回加密KEY
)

// 常量定义
const (
	FormatTime                 = "15:04:05"                //时间格式
	FormatTimeHm               = "15:04"                   //时间格式
	FormatDate                 = "2006-01-02"              //日期格式
	FormatDate2                = "06-01-02"                //日期格式
	FormatDateUnSpace          = "20060102"                //日期格式
	FormatDateTime             = "2006-01-02 15:04:05"     //完整时间格式
	HlbFormatDateTime          = "2006-01-02_15:04:05.999" //完整时间格式
	FormatDateTimeMinute       = "2006/01/02 15:04"        //时间格式 年/月/日 时:分
	FormatDateTimeMinute2      = "2006-01-02 15:04"        //时间格式 年-月-日 时:分
	FormatDateTimeUnSpace      = "20060102150405"          //完整时间格式
	FormatShortDateTimeUnSpace = "060102150405"            //省去开头两位年份的时间格式
	EmptyDateTimeStr           = "0000-00-00 00:00:00"     //DateTime零值字符串
	EmptyDateStr               = "0000-00-00"              //Date零值字符串
	FormatMonthDayUnSpace      = "0102"                    //日期格式
	FormatMonthDayUnSpace2     = "01.02"                   //日期格式
	FormatYearMonthDate        = "2006-01"                 //日期格式
	FormatYearDate             = "2006"                    //日期格式
	PageSize15                 = 15                        //列表页每页数据量
	PageSize5                  = 5
	PageSize10                 = 10
	PageSize20                 = 20
	PageSize30                 = 30
	PageSize50                 = 50
)

const (
	APPNAME          = "弘则-CRM管理后台"
	EmailSendToUsers = "glji@hzinsights.com;pyan@hzinsights.com;cxzhang@hzinsights.com;hsun@hzinsights.com"
)

// 手机号，电子邮箱正则
const (
	RegularMobile = "^((13[0-9])|(14[5|7])|(15([0-3]|[5-9]))|(18[0-9])|(17[0-9])|(16[0-9])|(19[0-9]))\\d{8}$" //手机号码
	RegularEmail  = `\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*`                                             //匹配电子邮箱
)

// 验证码code
const (
	REGISTER_CODE = iota + 1 //注册
	LOGIN_CODE               //登录
)

// 聚合短信
var (
	JhGnTplId  = "65692"                            //聚合国内模板编码
	JhGjTplId  = "10054"                            //聚合国内模板编码
	JhGnAppKey = "4c8504c49dd335e99cfd7b6a3a9e2415" //聚合国内AppKey
	JhGjAppKey = "3326ad2c1047a4cd92ace153e6044ca3" //聚合国内AppKey
)

// 科大讯飞--语音合成
const (
	XfSTATUS_FIRST_FRAME    = 0 //第一帧标识
	XfSTATUS_CONTINUE_FRAME = 1 //中间帧标识
	XfSTATUS_LAST_FRAME     = 2 //最后一帧标识
	XfAPPID                 = "5ed70e9d"
	XfAPIKey                = "d580509ca262e9586fb65a7064d5ce77"
	XfAPISecret             = "a085720dc55850c720fa5576335f847a"
	XfHostUrl               = "wss://tts-api.xfyun.cn/v2/tts"
	XfOrigin                = "http://tts-api.xfyun.cn/"
	XfHost                  = "tts-api.xfyun.cn"
	XfMaxFontSize           = 8000
	XfVcn                   = "x2_chaoge" //发言人
)

//OSS
/*var (
	Endpoint   string = "oss-cn-shanghai.aliyuncs.com"
	Bucketname string = "hongze"

	Imghost          string = "http://hongze.oss-cn-shanghai.aliyuncs.com/"
	Upload_dir       string = "static/images/"
	Upload_Audio_Dir string = "static/audio/"

	AccessKeyId     string = "LTAIFMZYQhS2BTvW"
	AccessKeySecret string = "12kk1ptCHoGWedhBnKRVW5hRJzq9Fq"
)
*/

// baidu
const (
	BdAppID     = "23047694"
	BdApiKey    = "RlisEen1Imd8haXx5Tqirstd"
	BdSecretKey = "tT75bhMW5UlmoA0flyQsjgurZzSWfuB9"
)

// 客户状态
const (
	COMPANY_STATUS_TRY_OUT           = "试用"
	COMPANY_STATUS_X_CLASS_TRY_OUT   = "X类试用" //最早定义为永续
	COMPANY_STATUS_FOREVER           = "永续"
	COMPANY_STATUS_FREEZE            = "冻结"
	COMPANY_STATUS_LOSE              = "流失"
	COMPANY_STATUS_LOSE_FLAG         = "loss"
	COMPANY_STATUS_FORMAL            = "正式"
	COMPANY_STATUS_POTENTIAL         = "潜在"
	COMPANY_STATUS_CLOSE             = "关闭"
	COMPANY_STATUS_CLOSE_FLAG        = "close"
	COMPANY_STATUS_TRY_OUT_COUNT     = 60
	COMPANY_STATUS_TRY_OUT_COUNT_RAI = 40 // 权益试用客户上限

	COMPANY_APPROVE_STATUS = "待审批"
)

// 管理员，ficc管理员，ficc销售，权益管理员，权益销售。
// 角色类型/类型编码
const (
	ROLE_TYPE_ADMIN       = "管理员"
	ROLE_TYPE_FICC_ADMIN  = "ficc管理员"
	ROLE_TYPE_FICC_SELLER = "ficc销售"
	ROLE_TYPE_RAI_ADMIN   = "权益管理员"
	ROLE_TYPE_RAI_SELLER  = "权益销售"
	ROLE_TYPE_RAI_PRODUCT = "权益产品"

	ROLE_TYPE_FICC_GROUP      = "ficc销售组长"
	ROLE_TYPE_FICC_MANAGER    = "ficc销售主管"
	ROLE_TYPE_RAI_GROUP       = "权益销售组长"
	ROLE_TYPE_FICC_DEPARTMENT = "ficc部门经理"
	ROLE_TYPE_RAI_DEPARTMENT  = "权益部门经理"
	ROLE_TYPE_FICC_RESEARCHR  = "ficc研究员"
	ROLE_TYPE_RAI_RESEARCHR   = "权益研究员"
	ROLE_NAME_FICC_DIRECTOR   = "ficc销售经理" // 实际角色类型为ficc销售主管

	ROLE_TYPE_CODE_ADMIN           = "admin"           //管理员
	ROLE_TYPE_CODE_FICC_ADMIN      = "ficc_admin"      //ficc管理员
	ROLE_TYPE_CODE_FICC_SELLER     = "ficc_seller"     //ficc销售
	ROLE_TYPE_CODE_RAI_ADMIN       = "rai_admin"       //权益管理员
	ROLE_TYPE_CODE_RAI_SELLER      = "rai_seller"      //权益销售
	ROLE_TYPE_CODE_FICC_GROUP      = "ficc_group"      //ficc销售主管
	ROLE_TYPE_CODE_RAI_GROUP       = "rai_group"       //ficc组长
	ROLE_TYPE_CODE_FICC_DEPARTMENT = "ficc_department" //ficc部门经理
	ROLE_TYPE_CODE_RAI_DEPARTMENT  = "rai_department"  //权益部门经理
	ROLE_TYPE_CODE_FICC_RESEARCHR  = "ficc_researcher" //ficc研究员
	ROLE_TYPE_CODE_RESEARCHR       = "researcher"      //ficc研究员（最早定义的）
	ROLE_TYPE_CODE_RAI_RESEARCHR   = "rai_researcher"  //权益研究员
	ROLE_TYPE_CODE_COMPLIANCE      = "compliance"      //合规角色
	ROLE_TYPE_CODE_FINANCE         = "finance"         //财务角色
	ROLE_TYPE_CODE_FICC_TEAM       = "ficc_team"       //ficc销售组长

	ROLE_TYPE_SELLERS = "'ficc_admin','ficc_seller','ficc_team','rai_admin','rai_seller','ficc_group','rai_group','ficc_department','rai_department','compliance','finance'"
)

// 客户类型
const (
	COMPANY_CLASSIFY_FICC    = "ficc"
	COMPANY_CLASSIFY_RAI     = "权益"
	COMPANY_CLASSIFY_PARTNER = "合作伙伴"
)

const (
	COMPANY_PRODUCT_FICC_ID   = 1
	COMPANY_PRODUCT_FICC_NAME = "ficc"
	COMPANY_PRODUCT_RAI_ID    = 2
	COMPANY_PRODUCT_RAI_NAME  = "权益"
	RAI_DEPARTMENT_ID         = 5 // 权益部门ID
)

var PermissionFiccClassifyArr = [...]string{"宏观经济", "化工产业", "建材产业", "有色产业", "新能源", "市场策略", "固定收益"}
var PermissionAllClassifyArr = [...]string{"宏观经济", "化工产业", "建材产业", "有色产业", "新能源", "市场策略", "固定收益", "权益"}

//apply_method:申请类型：1:试用->正式,2:冻结—>试用,3:流失—>正式,4:试用延期,5:原销售申请领取流失客户，6:正式客户申请服务更新

// 数据来源渠道
const (
	DATA_SOURCE_THS                                  = iota + 1 //同花顺
	DATA_SOURCE_WIND                                            //wind->2
	DATA_SOURCE_PB                                              //彭博->3
	DATA_SOURCE_CALCULATE                                       //指标运算->4
	DATA_SOURCE_CALCULATE_LJZZY                                 //累计值转月->5
	DATA_SOURCE_CALCULATE_TBZ                                   //同比值->6
	DATA_SOURCE_CALCULATE_TCZ                                   //同差值->7
	DATA_SOURCE_CALCULATE_NSZYDPJJS                             //N数值移动平均计算->8
	DATA_SOURCE_MANUAL                                          //手工指标->9
	DATA_SOURCE_LZ                                              //隆众->10
	DATA_SOURCE_YS                                              //有色->11
	DATA_SOURCE_CALCULATE_HBZ                                   //环比值->12
	DATA_SOURCE_CALCULATE_HCZ                                   //环差值->13
	DATA_SOURCE_CALCULATE_BP                                    //变频->14
	DATA_SOURCE_GL                                              //钢联->15
	DATA_SOURCE_ZZ                                              //郑商所->16
	DATA_SOURCE_DL                                              //大商所->17
	DATA_SOURCE_SH                                              //上期所->18
	DATA_SOURCE_CFFEX                                           //中金所->19
	DATA_SOURCE_SHFE                                            //上期能源->20
	DATA_SOURCE_GIE                                             //欧洲天然气->21
	DATA_SOURCE_CALCULATE_TIME_SHIFT                            //时间移位->22
	DATA_SOURCE_CALCULATE_ZJPJ                                  //直接拼接->23
	DATA_SOURCE_CALCULATE_LJZTBPJ                               //累计值同比拼接->24
	DATA_SOURCE_LT                                              //路透->25
	DATA_SOURCE_COAL                                            //中国煤炭网->26
	DATA_SOURCE_PYTHON                                          //python代码->27
	DATA_SOURCE_PB_FINANCE                                      //彭博财务数据->28
	DATA_SOURCE_GOOGLE_TRAVEL                                   //谷歌出行->29
	DATA_SOURCE_PREDICT                                         //普通预测指标->30
	DATA_SOURCE_PREDICT_CALCULATE                               //预测指标运算->31
	DATA_SOURCE_PREDICT_CALCULATE_TBZ                           //预测同比值->32
	DATA_SOURCE_PREDICT_CALCULATE_TCZ                           //预测同差值->33
	DATA_SOURCE_MYSTEEL_CHEMICAL                                //钢联化工->34
	DATA_SOURCE_CALCULATE_CJJX                                  //超季节性->35
	DATA_SOURCE_EIA_STEO                                        //eia steo报告->36
	DATA_SOURCE_CALCULATE_NHCC                                  //计算指标（拟合残差）->37
	DATA_SOURCE_COM_TRADE                                       //联合国商品贸易数据->38
	DATA_SOURCE_PREDICT_CALCULATE_NSZYDPJJS                     //预测指标 - N数值移动平均计算 -> 39
	DATA_SOURCE_CALCULATE_ADJUST                                //数据调整->40
	DATA_SOURCE_SCI                                             //卓创数据（红桃三）->41
	DATA_SOURCE_PREDICT_CALCULATE_LJZZY                         //预测指标 - 累计值转月->42
	DATA_SOURCE_PREDICT_CALCULATE_HBZ                           //预测指标 - 环比值->43
	DATA_SOURCE_PREDICT_CALCULATE_HCZ                           //预测指标 - 环差值->44
	DATA_SOURCE_PREDICT_CALCULATE_BP                            //预测指标 - 变频->45
	DATA_SOURCE_PREDICT_CALCULATE_TIME_SHIFT                    //预测指标 - 时间移位->46
	DATA_SOURCE_PREDICT_CALCULATE_ZJPJ                          //预测指标 - 直接拼接->47
	DATA_SOURCE_PREDICT_CALCULATE_LJZTBPJ                       //预测指标 - 累计值同比拼接->48
	DATA_SOURCE_PREDICT_CALCULATE_CJJX                          //预测指标 - 超季节性->49
	DATA_SOURCE_PREDICT_CALCULATE_NHCC                          //预测指标 - 计算指标（拟合残差）->50
	DATA_SOURCE_CALCULATE_JP                                    //变频->51
	DATA_SOURCE_CALCULATE_NH                                    //年化->52
	DATA_SOURCE_CALCULATE_KSZS                                  //扩散指数->53
	DATA_SOURCE_PREDICT_CALCULATE_JP                            //预测指标 - 计算指标(降频)->54
	DATA_SOURCE_PREDICT_CALCULATE_NH                            //预测指标 - 计算指标(年化)->55
	DATA_SOURCE_PREDICT_CALCULATE_KSZS                          //预测指标 - 计算指标(扩散指数)->56
	DATA_SOURCE_BAIINFO                                         //百川盈孚 ->57
	DATA_SOURCE_STOCK_PLANT                                     //存量装置 ->58
	DATA_SOURCE_CALCULATE_CORRELATION                           //滚动相关性->59
	DATA_SOURCE_NATIONAL_STATISTICS                             //国家统计局->60
	DATA_SOURCE_CALCULATE_LJZZJ                                 //累计值转季 -> 61
	DATA_SOURCE_CALCULATE_LJZ                                   //累计值 -> 62
	DATA_SOURCE_CALCULATE_LJZNCZJ                               //累计值(年初至今） -> 63
	DATA_SOURCE_PREDICT_CALCULATE_LJZZJ                         //预测指标 - 累计值转季->64
	DATA_SOURCE_PREDICT_CALCULATE_LJZ                           //预测指标 - 累计值 -> 65
	DATA_SOURCE_PREDICT_CALCULATE_LJZNCZJ                       //预测指标 - 累计值(年初至今） -> 66
	DATA_SOURCE_CALCULATE_STANDARD_DEVIATION                    //标准差->67
	DATA_SOURCE_CALCULATE_PERCENTILE                            //百分位图表->68
	DATA_SOURCE_PREDICT_CALCULATE_STANDARD_DEVIATION            //预测标准差->69
	DATA_SOURCE_PREDICT_CALCULATE_PERCENTILE                    //预测百分位->70
	DATA_SOURCE_FUBAO                                = 71       //富宝->71
)

// 数据刷新频率
const (
	DATA_START_REFRESH_LIMIT = 7 //7个单位，日/周/月/季度/年
	DATA_END_DATE_LIMIT      = 4 //数据结束日期为，当前日期，加上4年时间
)

// 数据缓存
const (
	CATCH_EDB_DATA = "EDB_DATA_"
)

const (
	DATA_PREFIX       = "hz_data"
	CHART_PREFIX      = "hz_chart"
	EXCEL_DATA_PREFIX = "hz_excel_data"
)

const (
	Hz_Data_Url    = "http://datawind.hzinsights.com:8040/" //同花顺，万得接口服务地址
	Hz_Data_PB_Url = "http://datapb.hzinsights.com:8040/"   //彭博接口地址
	Hz_Data_LT_Url = "http://dataek.hzinsights.com:8040/"   //路透社接口地址
	EDB_DATA_LIMIT = 10
)

var Hz_Data_WIND_Url_List = []string{"http://datawind.hzinsights.com:8040/", "http://datawind2.hzinsights.com:8040/"}

var (
	Hz_Server_Data_Url string //同花顺，万得接口服务地址（阿里云windows服务器地址）
)

const (
	HZ_CHART_LIB_DETAIL             = "HZ_CHART_LIB_DETAIL_"            //图表数据缓存
	HZ_CHART_LIB_EXCEL_TABLE_DETAIL = "HZ_CHART_LIB_EXCEL_TABLE_DETAIL" //excel表格数据缓存
)

// 缓存key
const (
	CACHE_KEY_LOGS                      = "HZ_ADMIN_CACHE_KEY_LOGS"             //api用户操作日志队列
	CACHE_KEY_ADMIN                     = "calendar:admin:list"                 //系统用户列表缓存key
	CACHE_KEY_ADMIN_ID                  = "calendar:admin:id:list"              //系统用户列表缓存key
	CACHE_KEY_OLD_REPORT_PUBLISH        = "HZ_CACHE_KEY_OLD_REPORT_PUBLISH"     //老后台报告发布队列
	CACHE_ADMIN_YB_CONFIG               = "admin:yb_config:"                    //研报配置相关缓存前缀
	CACHE_WIND_URL                      = "CACHE_WIND_URL"                      //指标与wind服务器的绑定关系
	CACHE_CHART_INFO_DATA               = "chart:info:data:"                    //图表数据
	CACHE_CHART_CLASSIFY                = "chart:classify"                      //图表分类数据
	CACHE_IMPORT_MANUAL_DATA            = "import:manual:data"                  //手工数据导入后刷新
	CACHE_ACCESS_TOKEN_LOGIN            = "pc_admin:login:"                     //管理后台登录
	CACHE_ACCESS_TOKEN_LOGIN_NO_TRUST   = "pc_admin:login:no_trust:"            //管理后台登录（不可信登录态）
	CACHE_ABNORMAL_LOGIN                = "pc_admin:login:abnormal:"            //管理后台登录-异常登录
	CACHE_LOGIN_ERR_PASS                = "pc_admin:login:errPass:"             //管理后台登录-输入错误密码次数
	CACHE_FIND_PASS_VERIFY              = "pc_admin:findPass:verify:"           //找回密码校验成功标记
	CACHE_KEY_COMPANY_MATCH_PRE         = "admin:company:match:"                //客户名单匹配
	CACHE_KEY_MYSTEEL_REFRESH           = "mysteel_chemical:refresh"            //钢联化工刷新
	CACHE_KEY_DAYNEW_REFRESH            = "admin:day_new:refresh"               //每日资讯拉取企业微信聊天记录
	CACHE_KEY_DAYNEW_TRANSLATE          = "admin:day_new:translate"             //每日资讯中翻英
	CACHE_KEY_ADMIN_OPERATE_RECORD      = "HZ_ADMIN_CACHE_ADMIN_OPERATE_RECORD" //系统用户操作日志队列
	CACHE_KEY_SHANG_HAI_RS_CALENDAR_API = "hz_crm_shang_hai_rs_calendar_api"    //上海研究员日历同步队列

	CACHE_SYNC_ADMIN      = "hz_crm_eta:sync_admin"      // 同步用户的缓存队列key
	CACHE_SYNC_ROLE       = "hz_crm_eta:sync_role"       // 同步角色的缓存队列key
	CACHE_SYNC_DEPARTMENT = "hz_crm_eta:sync_department" // 同步部门的缓存队列key
	CACHE_SYNC_GROUP      = "hz_crm_eta:sync_group"      // 同步分组的缓存队列key
)

// 模板消息推送类型
const (
	TEMPLATE_MSG_REPORT                  = iota + 1 //日度点评报告推送
	TEMPLATE_MSG_INDEX                              //指标更新
	TEMPLATE_MSG_APPLY                              //审批通知
	TEMPLATE_MSG_RECEIVE                            //销售领取客户通知
	TEMPLATE_MSG_CYGX_ACTIVITY_CACLE                //查研观向活动取消通知
	TEMPLATE_MSG_CYGX_ACTIVITY_UPDATE               //查研观向活动更改时间通知
	TEMPLATE_MSG_CYGX_ARTICLE                       //关注的作者发布报告通知
	TEMPLATE_MSG_CYGX_DAY_REPORT                    //发送日报（周报、双周报、月报）
	TEMPLATE_MSG_ACTIVITY_APPOINTMENT               //活动预约/报名时间通知
	TEMPLATE_MSG_RECEIVE_PERMISSION                 //销售"添加客户/领取客户"权限变更通知
	TEMPLATE_MSG_YB_COMMUNITY_QUESTION              //研报问答社区
	TEMPLATE_MSG_CYGX_ACTIVITY_ADD                  //查研观向小程序活动更新推送 12
	TEMPLATE_MSG_CYGX_ARTICLE_ADD                   //查研观向报告更新推送  13
	TEMPLATE_MSG_YB_PRICE_DRIVEN                    //研报价格驱动 14
	TEMPLATE_MSG_SEAL_FINISHED                      //用印申请已迁回通知 15
	TEMPLATE_MSG_YB_COMMUNITY_VIDEO                 //研报视频社区 16
	TEMPLATE_MSG_YB_ROAD_VIDEO                      //研报线上路演 17
	TEMPLATE_MSG_CYGX_ROADSHOW_VIDEO                //查研观向微路演视频 18
	TEMPLATE_MSG_CYGX_MORNING_MEETING               //查研观向晨会点评 19
	TEMPLATE_MSG_YB_VOICE_BROADCAST                 //研报语音播报 20 (hongze_yb,hongze_task在用,此处占位)
	TEMPLATE_MSG_CYGX_ACTIVITY_CUSTOMIZE            //查研观向活动自定义模版消息 21
)

// EDB_LIB
var (
	APP_EDB_LIB_NAME_EN = "hongze_edb_lib"
	EDB_LIB_Md5_KEY     = "GuRaB6dY1bXOJcwG"
)

// 研报类型标识
var (
	REPORT_TYPE_DAY      = "day"
	REPORT_TYPE_WEEK     = "week"
	REPORT_TYPE_TWO_WEEK = "two_week"
	REPORT_TYPE_MONTH    = "month"
	REPORT_TYPE_OTHER    = "other"
)

// 策略平台对接地址
const (
	HZ_CELUE_API_Url = "https://vmp.hzinsights.com/v2api/"
)

// 微信用户user_record注册平台
const (
	USER_RECORD_PLATFORM_RDDP      = iota + 1 // 日度点评公众号
	USER_RECORD_PLATFORM_BACKSTAGE            // 管理后台
	USER_RECORD_PLATFORM_PC                   // PC端网站
	USER_RECORD_PLATFORM_CYGX                 // 查研观向小程序
	_
	USER_RECORD_PLATFORM_YB // 研报小程序
)

// 留言管理员头像
const DEFAULT_HONGZE_SYS_LOGO = "https://hzstatic.hzinsights.com/static/yb_wx/hongze_sys_default_head.png" //弘则官方默认头像
const DEFAULT_HONGZE_USER_LOGO = "https://hzstatic.hzinsights.com/static/icon/hzyb/default_avatar.png"     //个人中心默认头像、匿名用户留言默认头像

// GetFiccAdminDepartmentIds 获取ficc管理员的所属部门
func GetFiccAdminDepartmentIds() (idStr string) {
	if RunMode == "release" {
		idStr = `1,2,4,6`
	} else {
		idStr = `1,2,6`
	}
	return
}

const (
	CHART_PERMISSION_NAME_MF_YANXUAN        string = "研选订阅"
	LU_YAN_FU_WU                            string = "路演服务"
	CHART_PERMISSION_NAME_YANXUAN           string = "研选"
	CHART_PERMISSION_NAME_MAI_FANG_YANXUAN  string = "买方研选"
	CHART_PERMISSION_ID_YANXUAN             int    = 31      //权限研选订阅id
	YAN_XUAN_KOU_DIAN_BAO_ID                int    = 52      //研选扣点包ID
	YAN_XUAN_KOU_DIAN_BAO_NAME              string = "研选扣点包" //研选扣点包名称
	CE_LUE_NAME                             string = "策略"
	CE_LUE_ID                               int    = 23
	YI_YAO_NAME                             string = "医药"
	YI_YAO_ID                               int    = 22
	XIAO_FEI_NAME                           string = "消费"
	XIAO_FEI_ID                             int    = 21
	KE_JI_NAME                              string = "科技"
	KE_JI_ID                                int    = 20
	ZHI_ZAO_NAME                            string = "智造"
	ZHI_ZAO_ID                              int    = 19
	GU_SHOU_NAME                            string = "固收"
	ZHOU_QI_NAME                            string = "周期"
	GU_SHOU_ID                              int    = 100000 // 自定义权限类型ID ，十万起步
	YI_DONG_NAME                            string = "（易董）"
	YI_DONG_NAME_TWO                        string = "--易董"
	CYGX_ACTIVITY_TYPE_NAME_HZ              string = "弘则活动"
	CYGX_ACTIVITY_TYPE_NAME_YX              string = "研选活动"
	CYGX_LYJH                               string = "路演精华"
	PERMISSION_ID_UPGRADE                   int    = 100000 //行业权限升级的时候所添加的起步值
	CYGX_TACTICS_TIME_LINE_STATUS           string = "cygx_tactics_time_line_status"
	CYGX_GUSHOU_TIME_LINE_STATUS            string = "cygx_gushou_time_line_status"     //固收时间线展示配置
	CYGX_TAG_HOT_ACTIVITY_ID                string = "cygx_tag_hot_activity_id"         //标签管理自定义的热门活动ID
	TEMPLATE_MSG_CYGX_ACTIVITY_LIMIT_PEOPLE int    = 1001                               //查研观向修改活动人数限制之后，对于因为人数已满而失败的用户，推送模板消息 1001
	YI_DONG_ZHENG_TONG_YUN_TOKEN_KEY        string = "YI_DONG_ZHENG_TONG_YUN_TOKEN_KEY" //易董证通云的token，存Redis使用
	CYGX_USER_KEY_LABEL                            = "CYGX_USER_KEY_LABEL"              //查研观向用户标签
	TPL_MSG_WANG_YANG                              = "tpl_msg_wang_yang"                //汪洋手机号地址参数
	TPL_MSG_YANXAUN_APPROVAL                       = "tpl_msg_yanxaun_approval"         //【研选订阅】和【研选扣点包】转正/续约审批通过后，给冯柯然和汪洋和沈涛发送模板消息
	MicroRoadshowDefaultImgKey                     = "micro_roadshow_default_img"       // 音视频封面图
	TPL_MSG_NEI_RONG_ZU                            = "tpl_msg_nei_rong_zu"              //内容组四人
	TPL_MSG_WANG_FANG_WANG_YANG                    = "tpl_msg_wang_fang_wang_yang"      //权限模板消息接收人,王芳，汪洋
	PERMISSION_ID_YANXUAN_DIFF                     = 20000                              // 买方研选区分3w和5w的差值
	PERMISSION_ID_YANXUAN_10W_DIFF                 = 20032                              // 买方研选区分10W
	ZHUAN_JIA_NAME                          string = "专家"
	ZHUAN_JIA_ID                            int    = 29
	CHART_PERMISSION_NAME_70W                      = "70w大套餐" // 权益70w大套餐名称
	CHART_PERMISSION_ID_70W                        = 2001     // 权益70w大套餐表示的权限ID(自定义)
	CHART_PERMISSION_NAME_45W                      = "45w大套餐" // 权益45w大套餐名称
	CHART_PERMISSION_ID_45W                        = 2002     // 权益45w大套餐表示的权限ID(自定义)
	HONG_GUAN_NAME                          string = "宏观"
	CYGX_ARTICLE_TIME_LINE_KEY                     = "CYGX_ARTICLE_TIME_LINE_KEY" //产业时间线关联的文章key
	WX_USER_RAI_LABEL_KEY                          = "CYGX_WX_USER_RAI_LABEL_KEY" //用户列表标签key
)

// 权益cygx_config配置主键以后放这里
const (
	YANXUAN_SPECIAL_ARTICLE_BUTTON_MOBILE string = "yanxuan_special_article_button_mobile" //CRM研选专栏模块文章管理可以查看的手机号
	YANXUAN_SPECIAL_AUTHOR_BUTTON_MOBILE  string = "yanxuan_special_author_button_mobile"  //CRM研选专栏模块作者管理可以查看的手机号
)

var CYGX_REGISTER_PLATFORM_MAP = map[string]string{
	"1": "查研小程序",
	"2": "查研网页版",
	"5": "研选小程序",
	"6": "研选网页版",
}

var ACTIVITY_SPECIAL_TRIP_PERMISSION_NAME_OTHER = []string{"策略", "固收", "周期"} //专项调研活动带扣点的行业

const (
	CYGX_OBJ_ARTICLE            string = "article"            // 对象类型：文章
	CYGX_OBJ_ACTIVITY           string = "activity"           // 对象类型：活动
	CYGX_OBJ_ACTIVITYVIDEO      string = "activityvideo"      // 对象类型：活动视频
	CYGX_OBJ_ACTIVITYVOICE      string = "activityvoice"      // 对象类型：活动音频
	CYGX_OBJ_ACTIVITYSPECIAL    string = "activityspecial"    // 对象类型：专项调研活动
	CYGX_OBJ_MEETINGREVIEWCHAPT string = "meetingreviewchapt" // 对象类型：晨会精华
	CYGX_OBJ_ROADSHOW           string = "roadshow"           // 对象类型：路演
	CYGX_OBJ_REPORTSELECTION    string = "reportselection"    // 对象类型：报告精选（重点公司）
	CYGX_OBJ_PRODUCTINTERIOR    string = "productinterior"    // 对象类型：产品内测
	CYGX_OBJ_RESEARCHSUMMARY    string = "researchsummary"    // 对象类型：本周研究汇总
	CYGX_OBJ_MINUTESSUMMARY     string = "minutessummary"     // 对象类型：本周研究汇总
	CYGX_OBJ_YANXUANSPECIAL     string = "yanxuanspecial"     // 对象类型：研选专栏
	CYGX_OBJ_ASKSERIEVIDEO      string = "askserievideo"      // 对象类型：问答系列视频
	CYGX_OBJ_RS_CALENDAR        string = "rscalendar"         // 对象类型：研究员日历安排
	CYGX_OBJ_FICC_REPORT        string = "ficcreport"         // 对象类型：FICC研报
	CYGX_OBJ_FICC_REPORT_XCX    string = "ficcreportxcx"      // 对象类型：FICC研报小程序
)

const (
	SendTemplateMsgAuthorization = "dc855fce962a639faa779cbdd4cd332f"
)

const (
	ReportFrequencyDay     = "日度"
	ReportFrequencyWeek    = "周度"
	ReportFrequencyTwoWeek = "双周度"
	ReportFrequencyMonth   = "月度"
	ReportFrequencyDefault = "不定时"
)

const (
	HZ_COMPANY_ID        = 16
	DEFAULT_COUNTRY_CODE = "86"
)

// 微信用户wx_user注册平台
const (
	WX_USER_REGISTER_PLATFORM_wechat = iota + 1 // 微信端
	WX_USER_REGISTER_PLATFORM_web               // 网页端
	WX_USER_REGISTER_PLATFORM_ADMIN             // 管理后台
	WX_USER_REGISTER_PLATFORM_mini              // 小程序端
)

// 查研观向小程序 模板消息地址路由
const (
	WX_MSG_PATH_ARTICLE_DETAIL                  = "pageMy/reportDetail/reportDetail?IsSendWx=1&id="                          //文章详情模板消息地址
	WX_MSG_PATH_ACTIVITY_SPECIAL_DETAIL         = "activityPages/specialDetail/specialDetail?IsSendWx=1&id="                 //专项调研活动模板消息地址
	WX_MSG_PATH_ROAD_ESSENCE                    = "reportPages/roadEssence/roadEssence?IsSendWx=1&id="                       //路演精华模板消息地址
	WX_MSG_PATH_ACTIVITY_DETAIL                 = "activityPages/activityDetail/activityDetail?IsSendWx=1&id="               //活动模板消息地址
	WX_MSG_PATH_PRODUCTINTERIOR_DETAIL          = "reportPages/internalDetials/internalDetials?IsSendWx=1&id="               //产品内测模版消息地址
	WX_MSG_PATH_ACTIVITY_SIGNIN                 = "pages-signIn/isSignIn/isSignIn"                                           //扫s码签到地址
	WX_MSG_PATH_THIS_WEEK_DETAIL                = "/reportPages/reportSecretDetail/reportSecretDetail?type=2&IsSendWx=1&id=" //本周研究汇总详情模板消息地址
	WX_MSG_PATH_LAST_WEEK_DETAIL                = "/reportPages/reportSecretDetail/reportSecretDetail?type=3&IsSendWx=1&id=" //上周纪要汇总详情模板消息地址
	WX_MSG_PATH_KEY_COMPANY_DETAIL              = "/reportPages/keyCompany/keyCompany?IsSendWx=1&id="                        //重点公司详情模板消息地址
	WX_MSG_PATH_INDUSTRY_DETAIL                 = "/reportPages/IndustryReport/IndustryReport?IsSendWx=1&id="                //产业详情模板消息地址
	CYGX_YANXUAN_POINTS_KEY              string = "CYGX_YANXUAN_POINTS_KEY"                                                  //查研观向研选活动扣点KEY(冲突，先放这里)
	WX_MSG_PATH_YX_SPECIAL_DETAIL               = "pages-purchaser/noteAndViewpoint/noteAndViewpoint?IsSendWx=1&id="         //研选专栏详情
	WX_MSG_PATH_YX_SPECIAL_ENABLE_DETAIL        = "pages-purchaser/toExamine/toExamine?IsSendWx=1&id="                       //研选专栏审核详情页面
	WX_MSG_PATH_YX_SPECIAL_CENTER               = "pages-purchaser/contentAllPage/contentAllPage?Status=4"                   //研选专栏内容中心
	WX_MSG_PATH_QUESTIONNAIRE_DETAIL            = "pages-purchaser/themeVote/themeVote?IsSendWx=1&id="                       //问卷调查详情页
)

// 图表类型
const (
	CHART_SOURCE_DEFAULT                         = 1
	CHART_SOURCE_FUTURE_GOOD                     = 2
	CHART_SOURCE_CORRELATION                     = 3 // 相关性图表
	CHART_SOURCE_ROLLING_CORRELATION             = 4 // 滚动相关性图表
	CHART_SOURCE_FUTURE_GOOD_PROFIT              = 5 // 商品利润曲线
	CHART_SOURCE_LINE_EQUATION                   = 6 // 拟合方程图表
	CHART_SOURCE_LINE_FEATURE_STANDARD_DEVIATION = 7 // 统计特征-标准差图表
	CHART_SOURCE_LINE_FEATURE_PERCENTILE         = 8 // 统计特征-百分位图表
	CHART_SOURCE_LINE_FEATURE_FREQUENCY          = 9 // 统计特征-频率分布图表
)

// 批量配置图表的位置来源
const (
	CHART_MULTIPLE_GRAPH_CURVE                           = 1  // 曲线图
	CHART_MULTIPLE_GRAPH_CORRELATION                     = 2  // 相关性图
	CHART_MULTIPLE_GRAPH_ROLLING_CORRELATION_ONE         = 3  // 滚动相关性图1
	CHART_MULTIPLE_GRAPH_ROLLING_CORRELATION_TWO         = 4  // 滚动相关性图2
	CHART_MULTIPLE_GRAPH_LINE_EQUATION_ONE               = 5  // 拟合方程-斜率图
	CHART_MULTIPLE_GRAPH_LINE_EQUATION_TWO               = 6  // 拟合方程-截距图
	CHART_MULTIPLE_GRAPH_LINE_EQUATION_THREE             = 7  // 拟合方程-相关性图
	CHART_MULTIPLE_GRAPH_LINE_FEATURE_STANDARD_DEVIATION = 8  // 统计特征-标准差图表
	CHART_MULTIPLE_GRAPH_LINE_FEATURE_PERCENTILE         = 9  // 统计特征-百分位图表
	CHART_MULTIPLE_GRAPH_LINE_FEATURE_FREQUENCY          = 10 // 统计特征-频率分布图表
)

// 图表样式类型
const (
	CHART_TYPE_CURVE           = 1  //曲线图
	CHART_TYPE_BAR             = 7  //柱形图
	CHART_TYPE_SECTION_SCATTER = 10 //截面散点图样式
)

// 指标类型
const (
	EDB_INFO_TYPE         = 0 //指标类型 0：普通指标
	PREDICT_EDB_INFO_TYPE = 1 //指标类型 1：预测指标
)

// FrequencyDaysMap 频度日期的map关系
var FrequencyDaysMap = map[string]int{
	"天": 1, "周": 7, "月": 30, "季": 90, "年": 365,
}

const (
	AiChatLimit = 500
)

// 系统来源
const (
	SOURCE_CRM_FLAG = 1
	SOURCE_ETA_FLAG = 2
)

// BusinessCodeSalt 商家编码盐值
const BusinessCodeSalt = "dr7WY0OZgGR7upw1"

// 查研观向 研选专栏 作者头像和背景
const (
	CYGX_YANXUAN_SPECIAL_HEAD_IMG_URL  = "https://hzstatic.hzinsights.com/cygx/yanxuan_special/head_img/Mask%20group-"
	CYGX_YANXUAN_SPECIAL_BG_IMG_URL    = "https://hzstatic.hzinsights.com/cygx/yanxuan_special/bg_img/"
	CYGX_YANXUAN_SPECIAL_BG_IMG_URL_PC = "https://hzstatic.hzinsights.com/cygx/yanxuan_special/bg_img/pc/"
)

// 验证码
const (
	CaptchaCachePrefix     = "captcha:lock:crm_" // 验证码缓存Key
	VerifyCodeExpireMinute = 15                  // 短信/邮箱验证码过期时间-分钟
	SmsLoginTplId          = "65692"             // 【弘则研究】您的验证码是XXX，如非本人操作，请忽略本短信
	SmsNewLoginTplId       = "254663"            // 【弘则研究】您的验证码是XXX，有效期15分钟
)

const CrmEtaAuthorization = "NIi1RbEmH0C2rksXtPGDPBBgRgTZY87Q"

const LoginCacheTime = 60 // 登录缓存时长, 分钟

// GetWeeklyDatabase 获取 weekly_report 库名
func GetWeeklyDatabase() (databaseName string) {
	if RunMode == "release" {
		databaseName = `weekly_report`
	} else {
		databaseName = `test_v2_weekly_report`
	}
	return
}
func GetCygxDatabase() (databaseName string) {
	if RunMode == "release" {
		databaseName = `hz_cygx`
	} else {
		databaseName = `test_hz_cygx`
	}
	return
}

const (
	EnCompanyIdStep = 10000000
)

const (
	MobileShenTao       = "18767183922" //沈涛手机号18767183922
	MobileZhangChuanXin = "15557270714" // 张传星手机号
	MobileWangFang      = "18621268829" // 王芳手机号
	MobileWuAngDi       = "18701809782" // 吴昂迪手机号
)

const (
	TelAreaCodeHome = "86" // 大陆区号
)

// 买方研选小程序 模版消息路由
const (
	WX_MSG_PATH_YX_ACTIVITY_DETAIL = "pages-activity/activityDetail/activityDetail?id=" //研选活动详情
	WX_MSG_PATH_YX_ARTICLE_DETAIL  = "pages-user/reportDetail/reportDetail?id="         //研选纪要详情
)
